/[gentoo-x86]/eclass/linux-mod.eclass
Gentoo

Diff of /eclass/linux-mod.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.75 Revision 1.106
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-mod.eclass,v 1.75 2007/10/03 12:53:10 phreak Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-mod.eclass,v 1.106 2012/08/28 15:28:01 mpagano Exp $
4 4
5# @ECLASS: linux-mod.eclass
6# @MAINTAINER:
7# kernel-misc@gentoo.org
8# @AUTHOR:
9# John Mylchreest <johnm@gentoo.org>,
10# Stefan Schweizer <genstef@gentoo.org>
11# @BLURB: It provides the functionality required to install external modules against a kernel source tree.
12# @DESCRIPTION:
5# Description: This eclass is used to interface with linux-info in such a way 13# This eclass is used to interface with linux-info.eclass in such a way
6# to provide the functionality required and initial functions 14# to provide the functionality and initial functions
7# required to install external modules against a kernel source 15# required to install external modules against a kernel source
8# tree. 16# tree.
9#
10# Author(s): John Mylchreest <johnm@gentoo.org>,
11# Stefan Schweizer <genstef@gentoo.org>
12# Maintainer: kernel-misc@gentoo.org
13#
14# Please direct your bugs to the current eclass maintainer :)
15 17
16# A Couple of env vars are available to effect usage of this eclass 18# A Couple of env vars are available to effect usage of this eclass
17# These are as follows: 19# These are as follows:
18# 20
19# Env Var Option Default Description 21# @ECLASS-VARIABLE: KERNEL_DIR
20# KERNEL_DIR <string> /usr/src/linux The directory containing kernel 22# @DESCRIPTION:
21# the target kernel sources. 23# A string containing the directory of the target kernel sources. The default value is
22# ECONF_PARAMS <string> The parameters to pass to econf. 24# "/usr/src/linux"
25
26# @ECLASS-VARIABLE: ECONF_PARAMS
27# @DESCRIPTION:
28# It's a string containing the parameters to pass to econf.
23# If this is not set, then econf 29# If this is not set, then econf isn't run.
24# isn't run.
25# BUILD_PARAMS <string> The parameters to pass to emake.
26# BUILD_TARGETS <string> clean modules The build targets to pass to
27# make.
28# MODULE_NAMES <string> This is the modules which are
29# to be built automatically using
30# the default pkg_compile/install.
31# They are explained properly
32# below. It will only make
33# BUILD_TARGETS once in any
34# directory.
35 30
36# MODULE_NAMES - Detailed Overview 31# @ECLASS-VARIABLE: BUILD_PARAMS
32# @DESCRIPTION:
33# It's a string with the parameters to pass to emake.
34
35# @ECLASS-VARIABLE: BUILD_TARGETS
36# @DESCRIPTION:
37# It's a string with the build targets to pass to make. The default value is "clean modules"
38
39# @ECLASS-VARIABLE: MODULE_NAMES
40# @DESCRIPTION:
41# It's a string containing the modules to be built automatically using the default
42# src_compile/src_install. It will only make ${BUILD_TARGETS} once in any directory.
37# 43#
38# The structure of each MODULE_NAMES entry is as follows: 44# The structure of each MODULE_NAMES entry is as follows:
45#
39# modulename(libdir:srcdir:objdir) 46# modulename(libdir:srcdir:objdir)
47#
48# where:
49#
50# modulename = name of the module file excluding the .ko
51# libdir = place in system modules directory where module is installed (by default it's misc)
52# srcdir = place for ebuild to cd to before running make (by default it's ${S})
53# objdir = place the .ko and objects are located after make runs (by default it's set to srcdir)
54#
55# To get an idea of how these variables are used, here's a few lines
56# of code from around line 540 in this eclass:
57#
58# einfo "Installing ${modulename} module"
59# cd ${objdir} || die "${objdir} does not exist"
60# insinto /lib/modules/${KV_FULL}/${libdir}
61# doins ${modulename}.${KV_OBJ} || die "doins ${modulename}.${KV_OBJ} failed"
62#
40# for example: 63# For example:
41# MODULE_NAMES="module_pci(pci:${S}/pci:${S}) module_usb(usb:${S}/usb:${S})" 64# MODULE_NAMES="module_pci(pci:${S}/pci:${S}) module_usb(usb:${S}/usb:${S})"
42# 65#
43# what this would do is 66# what this would do is
67#
44# cd ${S}/pci 68# cd "${S}"/pci
45# make ${BUILD_PARAMS} ${BUILD_TARGETS} 69# make ${BUILD_PARAMS} ${BUILD_TARGETS}
46# cd ${S} 70# cd "${S}"
47# insinto /lib/modules/${KV_FULL}/pci 71# insinto /lib/modules/${KV_FULL}/pci
48# doins module_pci.${KV_OBJ} 72# doins module_pci.${KV_OBJ}
49# 73#
50# cd ${S}/usb 74# cd "${S}"/usb
51# make ${BUILD_PARAMS} ${BUILD_TARGETS} 75# make ${BUILD_PARAMS} ${BUILD_TARGETS}
52# cd ${S} 76# cd "${S}"
53# insinto /lib/modules/${KV_FULL}/usb 77# insinto /lib/modules/${KV_FULL}/usb
54# doins module_usb.${KV_OBJ} 78# doins module_usb.${KV_OBJ}
55#
56# if the srcdir isnt specified, it assumes ${S}
57# if the libdir isnt specified, it assumes misc.
58# if the objdir isnt specified, it assumes srcdir
59 79
60# There is also support for automatyed modules.d file generation. 80# There is also support for automated modprobe.d/modules.d(2.4) file generation.
61# This can be explicitly enabled by setting any of the following variables. 81# This can be explicitly enabled by setting any of the following variables.
82
83# @ECLASS-VARIABLE: MODULESD_<modulename>_ENABLED
84# @DESCRIPTION:
85# This is used to disable the modprobe.d/modules.d file generation otherwise the file will be
86# always generated (unless no MODULESD_<modulename>_* variable is provided). Set to "no" to disable
87# the generation of the file and the installation of the documentation.
88
89# @ECLASS-VARIABLE: MODULESD_<modulename>_EXAMPLES
90# @DESCRIPTION:
91# This is a bash array containing a list of examples which should
92# be used. If you want us to try and take a guess set this to "guess".
62# 93#
94# For each array_component it's added an options line in the modprobe.d/modules.d file
63# 95#
64# MODULESD_${modulename}_ENABLED This enables the modules.d file 96# options array_component
65# generation even if we dont 97#
66# specify any additional info. 98# where array_component is "<modulename> options" (see modprobe.conf(5))
67# MODULESD_${modulename}_EXAMPLES This is a bash array containing 99
68# a list of examples which should 100# @ECLASS-VARIABLE: MODULESD_<modulename>_ALIASES
69# be used. If you want us to try and 101# @DESCRIPTION:
70# take a guess. Set this to "guess" 102# This is a bash array containing a list of associated aliases.
71# MODULESD_${modulename}_ALIASES This is a bash array containing 103#
72# a list of associated aliases. 104# For each array_component it's added an alias line in the modprobe.d/modules.d file
73# MODULESD_${modulename}_ADDITIONS This is a bash array containing 105#
74# A list of additional things to 106# alias array_component
75# add to the bottom of the file. 107#
76# This can be absolutely anything. 108# where array_component is "wildcard <modulename>" (see modprobe.conf(5))
109
110# @ECLASS-VARIABLE: MODULESD_<modulename>_ADDITIONS
111# @DESCRIPTION:
112# This is a bash array containing a list of additional things to
113# add to the bottom of the file. This can be absolutely anything.
77# Each entry is a new line. 114# Each entry is a new line.
78# MODULES_${modulename}_DOCS This is a string list which contains
79# the full path to any associated
80# documents for $modulename
81 115
82# The order of these is important as both of linux-info and eutils contain 116# @ECLASS-VARIABLE: MODULESD_<modulename>_DOCS
83# set_arch_to_kernel and set_arch_to_portage functions and the ones in eutils 117# @DESCRIPTION:
84# are deprecated in favor of the ones in linux-info. 118# This is a string list which contains the full path to any associated
85# See http://bugs.gentoo.org/show_bug.cgi?id=127506 119# documents for <modulename>. These files are installed in the live tree.
120
121# @ECLASS-VARIABLE: KV_OBJ
122# @DESCRIPTION:
123# It's a read-only variable. It contains the extension of the kernel modules.
86 124
87inherit eutils linux-info multilib 125inherit eutils linux-info multilib
88EXPORT_FUNCTIONS pkg_setup pkg_preinst pkg_postinst src_install src_compile pkg_postrm 126EXPORT_FUNCTIONS pkg_setup pkg_preinst pkg_postinst src_install src_compile pkg_postrm
89 127
90IUSE="kernel_linux" 128IUSE="kernel_linux"
91SLOT="0" 129SLOT="0"
92DESCRIPTION="Based on the $ECLASS eclass" 130DESCRIPTION="Based on the $ECLASS eclass"
93RDEPEND="kernel_linux? ( virtual/modutils )" 131RDEPEND="kernel_linux? ( virtual/modutils )"
94DEPEND="${RDEPEND} 132DEPEND="${RDEPEND}
95 sys-apps/sed" 133 sys-apps/sed
134 kernel_linux? ( virtual/linux-sources )"
96 135
97# eclass utilities 136# eclass utilities
98# ---------------------------------- 137# ----------------------------------
99 138
100check_vermagic() { 139check_vermagic() {
101 debug-print-function ${FUNCNAME} $* 140 debug-print-function ${FUNCNAME} $*
102 141
103 local curr_gcc_ver=$(gcc -dumpversion) 142 local curr_gcc_ver=$(gcc -dumpversion)
104 local tmpfile old_chost old_gcc_ver result=0 143 local tmpfile old_chost old_gcc_ver result=0
105 144
106 tmpfile=`find ${KV_DIR}/ -iname "*.o.cmd" -exec grep usr/lib/gcc {} \; -quit` 145 tmpfile=`find "${KV_DIR}/" -iname "*.o.cmd" -exec grep usr/lib/gcc {} \; -quit`
107 tmpfile=${tmpfile//*usr/lib} 146 tmpfile=${tmpfile//*usr/lib}
108 tmpfile=${tmpfile//\/include*} 147 tmpfile=${tmpfile//\/include*}
109 old_chost=${tmpfile//*gcc\/} 148 old_chost=${tmpfile//*gcc\/}
110 old_chost=${old_chost//\/*} 149 old_chost=${old_chost//\/*}
111 old_gcc_ver=${tmpfile//*\/} 150 old_gcc_ver=${tmpfile//*\/}
134 ewarn "to match the kernel, or recompile the kernel first." 173 ewarn "to match the kernel, or recompile the kernel first."
135 die "GCC Version Mismatch." 174 die "GCC Version Mismatch."
136 fi 175 fi
137} 176}
138 177
178# @FUNCTION: use_m
179# @RETURN: true or false
180# @DESCRIPTION:
181# It checks if the kernel version is greater than 2.6.5.
139use_m() { 182use_m() {
140 debug-print-function ${FUNCNAME} $* 183 debug-print-function ${FUNCNAME} $*
141 184
142 # if we haven't determined the version yet, we need too. 185 # if we haven't determined the version yet, we need too.
143 get_version; 186 get_version;
144 187
145 # if the kernel version is greater than 2.6.6 then we should use 188 # if the kernel version is greater than 2.6.6 then we should use
146 # M= instead of SUBDIRS= 189 # M= instead of SUBDIRS=
190 [ ${KV_MAJOR} -eq 3 ] && return 0
147 [ ${KV_MAJOR} -eq 2 -a ${KV_MINOR} -gt 5 -a ${KV_PATCH} -gt 5 ] && \ 191 [ ${KV_MAJOR} -eq 2 -a ${KV_MINOR} -gt 5 -a ${KV_PATCH} -gt 5 ] && \
148 return 0 || return 1 192 return 0 || return 1
149} 193}
150 194
195# @FUNCTION: convert_to_m
196# @USAGE: /path/to/the/file
197# @DESCRIPTION:
198# It converts a file (e.g. a makefile) to use M= instead of SUBDIRS=
151convert_to_m() { 199convert_to_m() {
152 debug-print-function ${FUNCNAME} $* 200 debug-print-function ${FUNCNAME} $*
153 201
154 if use_m 202 if use_m
155 then 203 then
156 [ ! -f "${1}" ] && \ 204 [ ! -f "${1}" ] && \
157 die "convert_to_m() requires a filename as an argument" 205 die "convert_to_m() requires a filename as an argument"
158 ebegin "Converting ${1/${WORKDIR}\//} to use M= instead of SUBDIRS=" 206 ebegin "Converting ${1/${WORKDIR}\//} to use M= instead of SUBDIRS="
159 sed -i 's:SUBDIRS=:M=:g' ${1} 207 sed -i 's:SUBDIRS=:M=:g' "${1}"
160 eend $? 208 eend $?
161 fi 209 fi
162} 210}
163 211
212# internal function
213#
214# FUNCTION: update_depmod
215# DESCRIPTION:
216# It updates the modules.dep file for the current kernel.
164update_depmod() { 217update_depmod() {
165 debug-print-function ${FUNCNAME} $* 218 debug-print-function ${FUNCNAME} $*
166 219
167 # if we haven't determined the version yet, we need too. 220 # if we haven't determined the version yet, we need too.
168 get_version; 221 get_version;
169 222
170 ebegin "Updating module dependencies for ${KV_FULL}" 223 ebegin "Updating module dependencies for ${KV_FULL}"
171 if [ -r ${KV_OUT_DIR}/System.map ] 224 if [ -r "${KV_OUT_DIR}"/System.map ]
172 then 225 then
173 depmod -ae -F ${KV_OUT_DIR}/System.map -b ${ROOT} -r ${KV_FULL} 226 depmod -ae -F "${KV_OUT_DIR}"/System.map -b "${ROOT}" ${KV_FULL}
174 eend $? 227 eend $?
175 else 228 else
176 ewarn 229 ewarn
177 ewarn "${KV_OUT_DIR}/System.map not found." 230 ewarn "${KV_OUT_DIR}/System.map not found."
178 ewarn "You must manually update the kernel module dependencies using depmod." 231 ewarn "You must manually update the kernel module dependencies using depmod."
179 eend 1 232 eend 1
180 ewarn 233 ewarn
181 fi 234 fi
182} 235}
183 236
237# internal function
238#
239# FUNCTION: update_modules
240# DESCRIPTION:
241# It calls the update-modules utility.
184update_modules() { 242update_modules() {
185 debug-print-function ${FUNCNAME} $* 243 debug-print-function ${FUNCNAME} $*
186 244
187 if [ -x /sbin/update-modules ] && \ 245 if [ -x /sbin/update-modules ] && \
188 grep -v -e "^#" -e "^$" ${D}/etc/modules.d/* >/dev/null 2>&1; then 246 grep -v -e "^#" -e "^$" "${D}"/etc/modules.d/* >/dev/null 2>&1; then
189 ebegin "Updating modules.conf" 247 ebegin "Updating modules.conf"
190 /sbin/update-modules 248 /sbin/update-modules
191 eend $? 249 eend $?
192 elif [ -x /sbin/update-modules ] && \ 250 elif [ -x /sbin/update-modules ] && \
193 grep -v -e "^#" -e "^$" ${D}/etc/modules.d/* >/dev/null 2>&1; then 251 grep -v -e "^#" -e "^$" "${D}"/etc/modules.d/* >/dev/null 2>&1; then
194 ebegin "Updating modules.conf" 252 ebegin "Updating modules.conf"
195 /sbin/update-modules 253 /sbin/update-modules
196 eend $? 254 eend $?
197 fi 255 fi
198} 256}
199 257
258# internal function
259#
260# FUNCTION: move_old_moduledb
261# DESCRIPTION:
262# It updates the location of the database used by the module-rebuild utility.
200move_old_moduledb() { 263move_old_moduledb() {
201 debug-print-function ${FUNCNAME} $* 264 debug-print-function ${FUNCNAME} $*
202 265
203 local OLDDIR=${ROOT}/usr/share/module-rebuild/ 266 local OLDDIR="${ROOT}"/usr/share/module-rebuild/
204 local NEWDIR=${ROOT}/var/lib/module-rebuild/ 267 local NEWDIR="${ROOT}"/var/lib/module-rebuild/
205 268
206 if [[ -f ${OLDDIR}/moduledb ]]; then 269 if [[ -f "${OLDDIR}"/moduledb ]]; then
207 [[ ! -d ${NEWDIR} ]] && mkdir -p ${NEWDIR} 270 [[ ! -d "${NEWDIR}" ]] && mkdir -p "${NEWDIR}"
208 [[ ! -f ${NEWDIR}/moduledb ]] && \ 271 [[ ! -f "${NEWDIR}"/moduledb ]] && \
209 mv ${OLDDIR}/moduledb ${NEWDIR}/moduledb 272 mv "${OLDDIR}"/moduledb "${NEWDIR}"/moduledb
210 rm -f ${OLDDIR}/* 273 rm -f "${OLDDIR}"/*
211 rmdir ${OLDDIR} 274 rmdir "${OLDDIR}"
212 fi 275 fi
213} 276}
214 277
278# internal function
279#
280# FUNCTION: update_moduledb
281# DESCRIPTION:
282# It adds the package to the /var/lib/module-rebuild/moduledb database used by the module-rebuild utility.
215update_moduledb() { 283update_moduledb() {
216 debug-print-function ${FUNCNAME} $* 284 debug-print-function ${FUNCNAME} $*
217 285
218 local MODULEDB_DIR=${ROOT}/var/lib/module-rebuild/ 286 local MODULEDB_DIR="${ROOT}"/var/lib/module-rebuild/
219 move_old_moduledb 287 move_old_moduledb
220 288
221 if [[ ! -f ${MODULEDB_DIR}/moduledb ]]; then 289 if [[ ! -f "${MODULEDB_DIR}"/moduledb ]]; then
222 [[ ! -d ${MODULEDB_DIR} ]] && mkdir -p ${MODULEDB_DIR} 290 [[ ! -d "${MODULEDB_DIR}" ]] && mkdir -p "${MODULEDB_DIR}"
223 touch ${MODULEDB_DIR}/moduledb 291 touch "${MODULEDB_DIR}"/moduledb
224 fi 292 fi
225 293
226 if ! grep -qs ${CATEGORY}/${PN}-${PVR} ${MODULEDB_DIR}/moduledb ; then 294 if ! grep -qs ${CATEGORY}/${PN}-${PVR} "${MODULEDB_DIR}"/moduledb ; then
227 einfo "Adding module to moduledb." 295 einfo "Adding module to moduledb."
228 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> ${MODULEDB_DIR}/moduledb 296 echo "a:1:${CATEGORY}/${PN}-${PVR}" >> "${MODULEDB_DIR}"/moduledb
229 fi 297 fi
230} 298}
231 299
300# internal function
301#
302# FUNCTION: remove_moduledb
303# DESCRIPTION:
304# It removes the package from the /var/lib/module-rebuild/moduledb database used by
305# the module-rebuild utility.
232remove_moduledb() { 306remove_moduledb() {
233 debug-print-function ${FUNCNAME} $* 307 debug-print-function ${FUNCNAME} $*
234 308
235 local MODULEDB_DIR=${ROOT}/var/lib/module-rebuild/ 309 local MODULEDB_DIR="${ROOT}"/var/lib/module-rebuild/
236 move_old_moduledb 310 move_old_moduledb
237 311
238 if grep -qs ${CATEGORY}/${PN}-${PVR} ${MODULEDB_DIR}/moduledb ; then 312 if grep -qs ${CATEGORY}/${PN}-${PVR} "${MODULEDB_DIR}"/moduledb ; then
239 einfo "Removing ${CATEGORY}/${PN}-${PVR} from moduledb." 313 einfo "Removing ${CATEGORY}/${PN}-${PVR} from moduledb."
240 sed -i -e "/.*${CATEGORY}\/${PN}-${PVR}.*/d" ${MODULEDB_DIR}/moduledb 314 sed -i -e "/.*${CATEGORY}\/${PN}-${PVR}.*/d" "${MODULEDB_DIR}"/moduledb
241 fi 315 fi
242} 316}
243 317
318# @FUNCTION: set_kvobj
319# @DESCRIPTION:
320# It sets the KV_OBJ variable.
244set_kvobj() { 321set_kvobj() {
245 debug-print-function ${FUNCNAME} $* 322 debug-print-function ${FUNCNAME} $*
246 323
247 if kernel_is 2 6 324 if kernel_is ge 2 6
248 then 325 then
249 KV_OBJ="ko" 326 KV_OBJ="ko"
250 else 327 else
251 KV_OBJ="o" 328 KV_OBJ="o"
252 fi 329 fi
255 # einfo "Using KV_OBJ=${KV_OBJ}" 332 # einfo "Using KV_OBJ=${KV_OBJ}"
256} 333}
257 334
258get-KERNEL_CC() { 335get-KERNEL_CC() {
259 debug-print-function ${FUNCNAME} $* 336 debug-print-function ${FUNCNAME} $*
337
338 if [[ -n ${KERNEL_CC} ]] ; then
339 echo "${KERNEL_CC}"
340 return
341 fi
260 342
261 local kernel_cc 343 local kernel_cc
262 if [ -n "${KERNEL_ABI}" ]; then 344 if [ -n "${KERNEL_ABI}" ]; then
263 # In future, an arch might want to define CC_$ABI 345 # In future, an arch might want to define CC_$ABI
264 #kernel_cc="$(get_abi_CC)" 346 #kernel_cc="$(get_abi_CC)"
268 kernel_cc=$(tc-getCC) 350 kernel_cc=$(tc-getCC)
269 fi 351 fi
270 echo "${kernel_cc}" 352 echo "${kernel_cc}"
271} 353}
272 354
355# internal function
356#
357# FUNCTION:
358# USAGE: /path/to/the/modulename_without_extension
359# RETURN: A file in /etc/modules.d/ (kernel < 2.6) or /etc/modprobe.d/ (kernel >= 2.6)
360# DESCRIPTION:
361# This function will generate and install the neccessary modprobe.d/modules.d file from the
362# information contained in the modules exported parms.
363# (see the variables MODULESD_<modulename>_ENABLED, MODULESD_<modulename>_EXAMPLES,
364# MODULESD_<modulename>_ALIASES, MODULESD_<modulename>_ADDITION and MODULESD_<modulename>_DOCS).
365#
366# At the end the documentation specified with MODULESD_<modulename>_DOCS is installed.
273generate_modulesd() { 367generate_modulesd() {
274 debug-print-function ${FUNCNAME} $* 368 debug-print-function ${FUNCNAME} $*
275
276 # This function will generate the neccessary modules.d file from the
277 # information contained in the modules exported parms
278 369
279 local currm_path currm currm_t t myIFS myVAR 370 local currm_path currm currm_t t myIFS myVAR
280 local module_docs module_enabled module_aliases \ 371 local module_docs module_enabled module_aliases \
281 module_additions module_examples module_modinfo module_opts 372 module_additions module_examples module_modinfo module_opts
282 373
316 module_modinfo="$(modinfo -p ${currm_path}.${KV_OBJ})" 407 module_modinfo="$(modinfo -p ${currm_path}.${KV_OBJ})"
317 module_config="${T}/modulesd-${currm}" 408 module_config="${T}/modulesd-${currm}"
318 409
319 ebegin "Preparing file for modules.d" 410 ebegin "Preparing file for modules.d"
320 #----------------------------------------------------------------------- 411 #-----------------------------------------------------------------------
321 echo "# modules.d configuration file for ${currm}" >> ${module_config} 412 echo "# modules.d configuration file for ${currm}" >> "${module_config}"
322 #----------------------------------------------------------------------- 413 #-----------------------------------------------------------------------
323 [[ -n ${module_docs} ]] && \ 414 [[ -n ${module_docs} ]] && \
324 echo "# For more information please read:" >> ${module_config} 415 echo "# For more information please read:" >> "${module_config}"
325 for t in ${module_docs} 416 for t in ${module_docs}
326 do 417 do
327 echo "# ${t//*\/}" >> ${module_config} 418 echo "# ${t//*\/}" >> "${module_config}"
328 done 419 done
329 echo >> ${module_config} 420 echo >> "${module_config}"
330 421
331 #----------------------------------------------------------------------- 422 #-----------------------------------------------------------------------
332 if [[ ${module_aliases} -gt 0 ]] 423 if [[ ${module_aliases} -gt 0 ]]
333 then 424 then
334 echo "# Internal Aliases - Do not edit" >> ${module_config} 425 echo "# Internal Aliases - Do not edit" >> "${module_config}"
335 echo "# ------------------------------" >> ${module_config} 426 echo "# ------------------------------" >> "${module_config}"
336 427
337 for((t=0; t<${module_aliases}; t++)) 428 for((t=0; t<${module_aliases}; t++))
338 do 429 do
339 echo "alias $(eval echo \${MODULESD_${currm}_ALIASES[$t]})" \ 430 echo "alias $(eval echo \${MODULESD_${currm}_ALIASES[$t]})" \
340 >> ${module_config} 431 >> "${module_config}"
341 done 432 done
342 echo '' >> ${module_config} 433 echo '' >> "${module_config}"
343 fi 434 fi
344 435
345 #----------------------------------------------------------------------- 436 #-----------------------------------------------------------------------
346 if [[ -n ${module_modinfo} ]] 437 if [[ -n ${module_modinfo} ]]
347 then 438 then
348 echo >> ${module_config} 439 echo >> "${module_config}"
349 echo "# Configurable module parameters" >> ${module_config} 440 echo "# Configurable module parameters" >> "${module_config}"
350 echo "# ------------------------------" >> ${module_config} 441 echo "# ------------------------------" >> "${module_config}"
351 myIFS="${IFS}" 442 myIFS="${IFS}"
352 IFS="$(echo -en "\n\b")" 443 IFS="$(echo -en "\n\b")"
353 444
354 for t in ${module_modinfo} 445 for t in ${module_modinfo}
355 do 446 do
356 myVAR="$(echo ${t#*:} | grep -e " [0-9][ =]" | sed "s:.*\([01][= ]\).*:\1:")" 447 myVAR="$(echo ${t#*:} | grep -e " [0-9][ =]" | sed "s:.*\([01][= ]\).*:\1:")"
357 if [[ -n ${myVAR} ]] 448 if [[ -n ${myVAR} ]]
358 then 449 then
359 module_opts="${module_opts} ${t%%:*}:${myVAR}" 450 module_opts="${module_opts} ${t%%:*}:${myVAR}"
360 fi 451 fi
361 echo -e "# ${t%%:*}:\t${t#*:}" >> ${module_config} 452 echo -e "# ${t%%:*}:\t${t#*:}" >> "${module_config}"
362 done 453 done
363 IFS="${myIFS}" 454 IFS="${myIFS}"
364 echo '' >> ${module_config} 455 echo '' >> "${module_config}"
365 fi 456 fi
366 457
367 #----------------------------------------------------------------------- 458 #-----------------------------------------------------------------------
368 if [[ $(eval echo \${MODULESD_${currm}_ALIASES[0]}) == guess ]] 459 if [[ $(eval echo \${MODULESD_${currm}_ALIASES[0]}) == guess ]]
369 then 460 then
370 # So lets do some guesswork eh? 461 # So lets do some guesswork eh?
371 if [[ -n ${module_opts} ]] 462 if [[ -n ${module_opts} ]]
372 then 463 then
373 echo "# For Example..." >> ${module_config} 464 echo "# For Example..." >> "${module_config}"
374 echo "# --------------" >> ${module_config} 465 echo "# --------------" >> "${module_config}"
375 for t in ${module_opts} 466 for t in ${module_opts}
376 do 467 do
377 echo "# options ${currm} ${t//:*}=${t//*:}" >> ${module_config} 468 echo "# options ${currm} ${t//:*}=${t//*:}" >> "${module_config}"
378 done 469 done
379 echo '' >> ${module_config} 470 echo '' >> "${module_config}"
380 fi 471 fi
381 elif [[ ${module_examples} -gt 0 ]] 472 elif [[ ${module_examples} -gt 0 ]]
382 then 473 then
383 echo "# For Example..." >> ${module_config} 474 echo "# For Example..." >> "${module_config}"
384 echo "# --------------" >> ${module_config} 475 echo "# --------------" >> "${module_config}"
385 for((t=0; t<${module_examples}; t++)) 476 for((t=0; t<${module_examples}; t++))
386 do 477 do
387 echo "options $(eval echo \${MODULESD_${currm}_EXAMPLES[$t]})" \ 478 echo "options $(eval echo \${MODULESD_${currm}_EXAMPLES[$t]})" \
388 >> ${module_config} 479 >> "${module_config}"
389 done 480 done
390 echo '' >> ${module_config} 481 echo '' >> "${module_config}"
391 fi 482 fi
392 483
393 #----------------------------------------------------------------------- 484 #-----------------------------------------------------------------------
394 if [[ ${module_additions} -gt 0 ]] 485 if [[ ${module_additions} -gt 0 ]]
395 then 486 then
396 for((t=0; t<${module_additions}; t++)) 487 for((t=0; t<${module_additions}; t++))
397 do 488 do
398 echo "$(eval echo \${MODULESD_${currm}_ADDITIONS[$t]})" \ 489 echo "$(eval echo \${MODULESD_${currm}_ADDITIONS[$t]})" \
399 >> ${module_config} 490 >> "${module_config}"
400 done 491 done
401 echo '' >> ${module_config} 492 echo '' >> "${module_config}"
402 fi 493 fi
403 494
404 #----------------------------------------------------------------------- 495 #-----------------------------------------------------------------------
405 496
406 # then we install it 497 # then we install it
498 if kernel_is ge 2 6; then
499 insinto /etc/modprobe.d
500 else
407 insinto /etc/modules.d 501 insinto /etc/modules.d
502 fi
408 newins ${module_config} ${currm_path//*\/} 503 newins "${module_config}" "${currm_path//*\/}.conf"
409 504
410 # and install any documentation we might have. 505 # and install any documentation we might have.
411 [[ -n ${module_docs} ]] && dodoc ${module_docs} 506 [[ -n ${module_docs} ]] && dodoc ${module_docs}
412 done 507 done
413 eend 0 508 eend 0
414 return 0 509 return 0
415} 510}
416 511
512# internal function
513#
514# FUNCTION: find_module_params
515# USAGE: A string "NAME(LIBDIR:SRCDIR:OBJDIR)"
516# RETURN: The string "modulename:NAME libdir:LIBDIR srcdir:SRCDIR objdir:OBJDIR"
517# DESCRIPTION:
518# Analyze the specification NAME(LIBDIR:SRCDIR:OBJDIR) of one module as described in MODULE_NAMES.
417find_module_params() { 519find_module_params() {
418 debug-print-function ${FUNCNAME} $* 520 debug-print-function ${FUNCNAME} $*
419 521
420 local matched_offset=0 matched_opts=0 test="${@}" temp_var result 522 local matched_offset=0 matched_opts=0 test="${@}" temp_var result
421 local i=0 y=0 z=0 523 local i=0 y=0 z=0
457} 559}
458 560
459# default ebuild functions 561# default ebuild functions
460# -------------------------------- 562# --------------------------------
461 563
564# @FUNCTION: linux-mod_pkg_setup
565# @DESCRIPTION:
566# It checks the CONFIG_CHECK options (see linux-info.eclass(5)), verifies that the kernel is
567# configured, verifies that the sources are prepared, verifies that the modules support is builtin
568# in the kernel and sets the object extension KV_OBJ.
462linux-mod_pkg_setup() { 569linux-mod_pkg_setup() {
463 debug-print-function ${FUNCNAME} $* 570 debug-print-function ${FUNCNAME} $*
464 571
572 local is_bin="${MERGE_TYPE}"
573
574 # If we are installing a binpkg, take a different path.
575 # use MERGE_TYPE if available (eapi>=4); else use non-PMS EMERGE_FROM (eapi<4)
576 if has ${EAPI} 0 1 2 3; then
577 is_bin=${EMERGE_FROM}
578 fi
579
580 if [[ ${is_bin} == binary ]]; then
581 linux-mod_pkg_setup_binary
582 return
583 fi
584
465 linux-info_pkg_setup; 585 linux-info_pkg_setup;
586 require_configured_kernel
466 check_kernel_built; 587 check_kernel_built;
467 strip_modulenames; 588 strip_modulenames;
468 [[ -n ${MODULE_NAMES} ]] && check_modules_supported 589 [[ -n ${MODULE_NAMES} ]] && check_modules_supported
469 set_kvobj; 590 set_kvobj;
470 # Commented out with permission from johnm until a fixed version for arches 591 # Commented out with permission from johnm until a fixed version for arches
471 # who intentionally use different kernel and userland compilers can be 592 # who intentionally use different kernel and userland compilers can be
472 # introduced - Jason Wever <weeve@gentoo.org>, 23 Oct 2005 593 # introduced - Jason Wever <weeve@gentoo.org>, 23 Oct 2005
473 #check_vermagic; 594 #check_vermagic;
474} 595}
475 596
597# @FUNCTION: linux-mod_pkg_setup_binary
598# @DESCRIPTION:
599# Perform all kernel option checks non-fatally, as the .config and
600# /proc/config.gz might not be present. Do not do anything that requires kernel
601# sources.
602linux-mod_pkg_setup_binary() {
603 debug-print-function ${FUNCNAME} $*
604 local new_CONFIG_CHECK
605 # ~ needs always to be quoted, else bash expands it.
606 for config in $CONFIG_CHECK ; do
607 optional='~'
608 [[ ${config:0:1} == "~" ]] && optional=''
609 new_CONFIG_CHECK="${new_CONFIG_CHECK} ${optional}${config}"
610 done
611 export CONFIG_CHECK="${new_CONFIG_CHECK}"
612 linux-info_pkg_setup;
613}
614
476strip_modulenames() { 615strip_modulenames() {
477 debug-print-function ${FUNCNAME} $* 616 debug-print-function ${FUNCNAME} $*
478 617
479 local i 618 local i
480 for i in ${MODULE_IGNORE}; do 619 for i in ${MODULE_IGNORE}; do
481 MODULE_NAMES=${MODULE_NAMES//${i}(*} 620 MODULE_NAMES=${MODULE_NAMES//${i}(*}
482 done 621 done
483} 622}
484 623
624# @FUNCTION: linux-mod_src_compile
625# @DESCRIPTION:
626# It compiles all the modules specified in MODULE_NAMES. For each module the econf command is
627# executed only if ECONF_PARAMS is defined, the name of the target is specified by BUILD_TARGETS
628# while the options are in BUILD_PARAMS (all the modules share these variables). The compilation
629# happens inside ${srcdir}.
630#
631# Look at the description of these variables for more details.
485linux-mod_src_compile() { 632linux-mod_src_compile() {
486 debug-print-function ${FUNCNAME} $* 633 debug-print-function ${FUNCNAME} $*
487 634
488 local modulename libdir srcdir objdir i n myARCH="${ARCH}" myABI="${ABI}" 635 local modulename libdir srcdir objdir i n myABI="${ABI}"
489 ARCH="$(tc-arch-kernel)" 636 set_arch_to_kernel
490 ABI="${KERNEL_ABI}" 637 ABI="${KERNEL_ABI}"
491 638
492 BUILD_TARGETS=${BUILD_TARGETS:-clean module} 639 BUILD_TARGETS=${BUILD_TARGETS:-clean module}
640 strip_modulenames;
641 cd "${S}"
642 touch Module.symvers
643 for i in ${MODULE_NAMES}
644 do
645 unset libdir srcdir objdir
646 for n in $(find_module_params ${i})
647 do
648 eval ${n/:*}=${n/*:/}
649 done
650 libdir=${libdir:-misc}
651 srcdir=${srcdir:-${S}}
652 objdir=${objdir:-${srcdir}}
653
654 if [ ! -f "${srcdir}/.built" ];
655 then
656 cd "${srcdir}"
657 ln -s "${S}"/Module.symvers Module.symvers
658 einfo "Preparing ${modulename} module"
659 if [[ -n ${ECONF_PARAMS} ]]
660 then
661 econf ${ECONF_PARAMS} || \
662 die "Unable to run econf ${ECONF_PARAMS}"
663 fi
664
665 # This looks messy, but it is needed to handle multiple variables
666 # being passed in the BUILD_* stuff where the variables also have
667 # spaces that must be preserved. If don't do this, then the stuff
668 # inside the variables gets used as targets for Make, which then
669 # fails.
670 eval "emake HOSTCC=\"$(tc-getBUILD_CC)\" \
671 CROSS_COMPILE=${CHOST}- \
672 LDFLAGS=\"$(get_abi_LDFLAGS)\" \
673 ${BUILD_FIXES} \
674 ${BUILD_PARAMS} \
675 ${BUILD_TARGETS} " \
676 || die "Unable to emake HOSTCC="$(tc-getBUILD_CC)" CROSS_COMPILE=${CHOST}- LDFLAGS="$(get_abi_LDFLAGS)" ${BUILD_FIXES} ${BUILD_PARAMS} ${BUILD_TARGETS}"
677 cd "${OLDPWD}"
678 touch "${srcdir}"/.built
679 fi
680 done
681
682 set_arch_to_portage
683 ABI="${myABI}"
684}
685
686# @FUNCTION: linux-mod_src_install
687# @DESCRIPTION:
688# It install the modules specified in MODULES_NAME. The modules should be inside the ${objdir}
689# directory and they are installed inside /lib/modules/${KV_FULL}/${libdir}.
690#
691# The modprobe.d/modules.d configuration file is automatically generated if the
692# MODULESD_<modulename>_* variables are defined. The only way to stop this process is by
693# setting MODULESD_<modulename>_ENABLED=no. At the end the documentation specified via
694# MODULESD_<modulename>_DOCS is also installed.
695#
696# Look at the description of these variables for more details.
697linux-mod_src_install() {
698 debug-print-function ${FUNCNAME} $*
699
700 local modulename libdir srcdir objdir i n
701
493 strip_modulenames; 702 strip_modulenames;
494 for i in ${MODULE_NAMES} 703 for i in ${MODULE_NAMES}
495 do 704 do
496 unset libdir srcdir objdir 705 unset libdir srcdir objdir
497 for n in $(find_module_params ${i}) 706 for n in $(find_module_params ${i})
500 done 709 done
501 libdir=${libdir:-misc} 710 libdir=${libdir:-misc}
502 srcdir=${srcdir:-${S}} 711 srcdir=${srcdir:-${S}}
503 objdir=${objdir:-${srcdir}} 712 objdir=${objdir:-${srcdir}}
504 713
505 if [ ! -f "${srcdir}/.built" ];
506 then
507 cd ${srcdir}
508 einfo "Preparing ${modulename} module"
509 if [[ -n ${ECONF_PARAMS} ]]
510 then
511 econf ${ECONF_PARAMS} || \
512 die "Unable to run econf ${ECONF_PARAMS}"
513 fi
514
515 emake HOSTCC="$(tc-getBUILD_CC)" CC="$(get-KERNEL_CC)" LDFLAGS="$(get_abi_LDFLAGS)" \
516 ${BUILD_FIXES} ${BUILD_PARAMS} ${BUILD_TARGETS} \
517 || die "Unable to make ${BUILD_FIXES} ${BUILD_PARAMS} ${BUILD_TARGETS}."
518 touch ${srcdir}/.built
519 cd ${OLDPWD}
520 fi
521 done
522
523 ARCH="${myARCH}"
524 ABI="${myABI}"
525}
526
527linux-mod_src_install() {
528 debug-print-function ${FUNCNAME} $*
529
530 local modulename libdir srcdir objdir i n
531
532 strip_modulenames;
533 for i in ${MODULE_NAMES}
534 do
535 unset libdir srcdir objdir
536 for n in $(find_module_params ${i})
537 do
538 eval ${n/:*}=${n/*:/}
539 done
540 libdir=${libdir:-misc}
541 srcdir=${srcdir:-${S}}
542 objdir=${objdir:-${srcdir}}
543
544 einfo "Installing ${modulename} module" 714 einfo "Installing ${modulename} module"
545 cd ${objdir} || die "${objdir} does not exist" 715 cd "${objdir}" || die "${objdir} does not exist"
546 insinto /lib/modules/${KV_FULL}/${libdir} 716 insinto /lib/modules/${KV_FULL}/${libdir}
547 doins ${modulename}.${KV_OBJ} || die "doins ${modulename}.${KV_OBJ} failed" 717 doins ${modulename}.${KV_OBJ} || die "doins ${modulename}.${KV_OBJ} failed"
548 cd ${OLDPWD} 718 cd "${OLDPWD}"
549 719
550 generate_modulesd ${objdir}/${modulename} 720 generate_modulesd "${objdir}/${modulename}"
551 done 721 done
552} 722}
553 723
724# @FUNCTION: linux-mod_pkg_preinst
725# @DESCRIPTION:
726# It checks what to do after having merged the package.
554linux-mod_pkg_preinst() { 727linux-mod_pkg_preinst() {
555 debug-print-function ${FUNCNAME} $* 728 debug-print-function ${FUNCNAME} $*
556 729
557 [ -d ${IMAGE}/lib/modules ] && UPDATE_DEPMOD=true || UPDATE_DEPMOD=false 730 [ -d "${D}lib/modules" ] && UPDATE_DEPMOD=true || UPDATE_DEPMOD=false
558 [ -d ${IMAGE}/etc/modules.d ] && UPDATE_MODULES=true || UPDATE_MODULES=false 731 [ -d "${D}etc/modules.d" ] && UPDATE_MODULES=true || UPDATE_MODULES=false
559 [ -d ${IMAGE}/lib/modules ] && UPDATE_MODULEDB=true || UPDATE_MODULEDB=false 732 [ -d "${D}lib/modules" ] && UPDATE_MODULEDB=true || UPDATE_MODULEDB=false
560} 733}
561 734
735# @FUNCTION: linux-mod_pkg_postinst
736# @DESCRIPTION:
737# It executes /sbin/depmod and adds the package to the /var/lib/module-rebuild/moduledb
738# database (if ${D}/lib/modules is created) and it runs /sbin/update-modules
739# (if ${D}/etc/modules.d is created).
562linux-mod_pkg_postinst() { 740linux-mod_pkg_postinst() {
563 debug-print-function ${FUNCNAME} $* 741 debug-print-function ${FUNCNAME} $*
564 742
565 ${UPDATE_DEPMOD} && update_depmod; 743 ${UPDATE_DEPMOD} && update_depmod;
566 ${UPDATE_MODULES} && update_modules; 744 ${UPDATE_MODULES} && update_modules;
567 ${UPDATE_MODULEDB} && update_moduledb; 745 ${UPDATE_MODULEDB} && update_moduledb;
568} 746}
569 747
748# @FUNCTION: linux-mod_pkg_postrm
749# @DESCRIPTION:
750# It removes the package from the /var/lib/module-rebuild/moduledb database but it doens't
751# call /sbin/depmod and /sbin/update-modules because the modules are still installed.
570linux-mod_pkg_postrm() { 752linux-mod_pkg_postrm() {
571 debug-print-function ${FUNCNAME} $* 753 debug-print-function ${FUNCNAME} $*
572 remove_moduledb; 754 remove_moduledb;
573} 755}

Legend:
Removed from v.1.75  
changed lines
  Added in v.1.106

  ViewVC Help
Powered by ViewVC 1.1.20